<template>
  <div v-if="dataLoaded && !hideBlock">
    <div v-if="!singleProductView" class="grid grid-cols-1 md:grid-cols-2">
      <MKProductDoubleWidget
        image-name="air_pro.png"
        :color="colorClass[0]"
        :product="productOne"
        view-class="md:w-48 xl:w-30"
      />
      <MKProductDoubleWidget
        image-name="air_pro.png"
        :color="colorClass[1]"
        :product="productTwo"
        view-class="md:w-48 xl:w-30"
      />
    </div>
    <div v-else>
      <MKProductSingleWidget
        :image-name="'air_pro.png'"
        color="bg-grey-10"
        :product="productThree"
        view-class="md:w-30 xl:w-48"
      />
    </div>
  </div>
</template>
<script>
import { mapState } from 'vuex'
import MKProductDoubleWidget from '~/components/D2C/organisms/MkProductWidget/MkProductDoubleWidget.vue'
import MKProductSingleWidget from '~/components/D2C/organisms/MkProductWidget/MkProductSingleWidget.vue'
export default {
  name: 'MkProductView',
  components: {
    MKProductDoubleWidget,
    MKProductSingleWidget,
  },
  props: {
    productString: {
      type: String,
      default: null,
    },
    colorClass: {
      type: Array,
      default: ['bg-grey-10', ''],
    },
  },
  data() {
    return {
      screenWidth: window.screen.width,
      singleProductView: true,
      dataLoaded: false,
      productOne: {},
      productTwo: {},
      productThree: {},
      hideBlock: false,
    }
  },
  async created() {
    if (!this.productString) return (this.hideBlock = true)
    window.addEventListener('resize', this.resizeEvent)
    try {
      const products = this.productString.split(',')
      if (products.length == 2) {
        this.singleProductView = false
        this.productOne = this.parseProductData(
          await this.$repositories.product.getBySku(
            products[0],
            this.CUSTOMER_ID
          )
        )
        this.productTwo = this.parseProductData(
          await this.$repositories.product.getBySku(
            products[1],
            this.CUSTOMER_ID
          )
        )
      } else {
        this.productThree = this.parseProductData(
          await this.$repositories.product.getBySku(
            products[0],
            this.CUSTOMER_ID
          )
        )
      }
      this.$forceUpdate()
      this.dataLoaded = true
    } catch (error) {
      console.log('report this error', error)
    }
  },
  methods: {
    resizeEvent() {
      this.screenWidth = window.screen.width
    },
    parseProductData(response) {
      const { data } = response
      const _getNodeVal = (obj, key) => {
        let retVal = null
        const keyObj = obj.find((o) => o.name == key)
        if (keyObj) {
          retVal = keyObj.value
        }
        return retVal
      }
      const { productBean, averageRating, reviewCount } = data // pick productBean,
      const { id: productId, masterData } = productBean
      const { current: currentNode } = masterData
      const { masterVariant } = currentNode
      const {
        price,
        attributes,
        key: productKey,
        sku: productSku,
      } = masterVariant
      const { value: productPriceMSRP, tiers } = price
      // tiers = this.$root.$utility.quoteFlowCheck(
      //   this.$store.state['CART_STORE']['IS_AUTHENTICATED'],
      //   this.$store.state['CART_STORE']['SHOW_QUOTE_FLOW'],
      //   'PRODUCT',
      //   tiers,
      //   this.$store
      // )
      // if (tiers == null) {
      //   tiers = []
      // }
      // tiers.sort((a, b) => {
      //   return a.minimumQuantity - b.minimumQuantity
      // })
      const locale = 'en-US'

      // let quoteOnlyProduct = false
      if (productId && this.$store.state.CART_STORE.QUOTE_ONLY_PRODUCT.length) {
        const Qproduct = this.$store.state.CART_STORE.QUOTE_ONLY_PRODUCT

        // for (let i = 0; i < Qproduct.length; i++) {
        //   if (productId === Qproduct[i]) {
        //     quoteOnlyProduct = true
        //     break
        //   }
        // }
      }
      const productDetail = {
        productId,
        productKey,
        productSku,
        productName: currentNode.name[locale],
        productDescription: currentNode.description[locale],
        productSlug: currentNode.slug[locale],
        productStockCount: _getNodeVal(attributes, 'inventoryThreshold'),
        productPriceMSRP,
        // productPriceTiers: tiers,
        averageRating,
        reviewCount,
        masterVariant,
        //  quoteOnlyProduct
      }
      // this.$store.commit('CART_STORE/SET_MINIMUM_QTY', {
      //   id: productId,
      //   minQty: (tiers.length && tiers[0]['minimumQuantity']) || null
      // })
      return productDetail
    },
  },
  computed: {
    ...mapState('USER_STORE', ['CUSTOMER_ID']),
  },
  destroyed() {
    window.removeEventListener('resize', this.resizeEvent)
  },
}
</script>
